
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>auto_ptr,shared_ptr 智能指针的使用 / iVAN</title>

    <meta name="description" content="auto_ptr,shared_ptr 智能指针的使用 Q: 那个auto_ptr是什么东东啊?为什么没有auto_array?A: 哦,auto_ptr是一个很简单的资源封装类,是在&lt;memory&gt;头文件中定义的.它使用&quot;资源分配即初始化&quot;技术来保证资源在发生异常时也能被安全释放(&quot;exception safety&quot;).一个auto_ptr封装了一个指针,也可以被当作指针来使用.当其生命周期到了尽头,auto_ptr会自动释放指针.例如: #include&lt;memory&gt; using  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">auto_ptr,shared_ptr 智能指针的使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>Q: 那个auto_ptr是什么东东啊？为什么没有auto_array？<br />A: 哦，auto_ptr是一个很简单的资源封装类，是在&lt;memory&gt;头文件中定义的。它使用“资源分配即初始化”技术来保证资源在发生异常时也能被安全释放（“exception safety”）。一个auto_ptr封装了一个指针，也可以被当作指针来使用。当其生命周期到了尽头，auto_ptr会自动释放指针。例如：<br /> #include&lt;memory&gt;<br /> using namespace std;</strong></p>
<p><strong> struct X {<br />  int m;<br />  // ..<br /> };</strong></p>
<p><strong> void f()<br /> {<br />  auto_ptr&lt;X&gt; p(new X);<br />  X* q = new X;</strong></p>
<p><strong>  p-&gt;m++;  // use p just like a pointer<br />  q-&gt;m++;<br />  // ...</strong></p>
<p><strong>  delete q;<br /> }<br />如果在代码用// ...标注的地方抛出异常，那么p会被正常删除——这个功劳应该记在auto_ptr的析构函数头上。不过，q指向的X类型对象就没有被释放（因为不是用auto_ptr定义的）。详情请见TC++PL 14.4.2节。<br />Auto_ptr是一个轻量级的类，没有引入引用计数机制。如果你把一个auto_ptr（比如，ap1）赋给另一个auto_ptr（比如，ap2），那么ap2将持有实际指针，而ap1将持有零指针。例如：</strong></p>
<p><strong> #include&lt;memory&gt;<br /> #include&lt;iostream&gt;<br /> using namespace std;</strong></p>
<p><strong> struct X {<br />  int m;<br />  // ..<br /> };</strong></p>
<p><strong> int main()<br /> {<br />  auto_ptr&lt;X&gt; p(new X);<br />  auto_ptr&lt;X&gt; q(p);<br />  cout &lt;&lt; "p " &lt;&lt; p.get() &lt;&lt; " q " &lt;&lt; q.get() &lt;&lt; "\n";<br /> }</strong></p>
<p><strong> <br />运行结果应该是先显示一个零指针，然后才是一个实际指针，就像这样： <br /> p 0x0 q 0x378d0</strong></p>
<p><strong> <br />auto_ptr::get()返回实际指针。<br />这里，语义似乎是“转移”，而非“拷贝”，这或许有点令人惊讶。特别要注意的是，不要把auto_ptr作为标准容器的参数——标准容器要求通常的拷贝语义。例如：</strong></p>
<p><strong> std::vector&lt;auto_ptr&lt;X&gt; &gt;v; // error</strong></p>
<p><strong>一个auto_ptr只能持有指向单个元素的指针，而不是数组指针：</strong></p>
<p><strong> void f(int n)<br /> {<br />  auto_ptr&lt;X&gt; p(new X[n]); // error<br />  // ...<br /> }</strong></p>
<p><strong> <br />上述代码会出错，因为析构函数是使用delete而非delete[]来释放指针的，所以后面的n-1个X没有被释放。 <br />那么，看来我们应该用一个使用delete[]来释放指针的，叫auto_array的类似东东来放数组了？哦，不，不，没有什么auto_array。理由是，不需要有啊——我们完全可以用vector嘛：</strong></p>
<p><strong> void f(int n)<br /> {<br />  vector&lt;X&gt; v(n);<br />  // ...<br /> }</strong></p>
<p><strong> <br />如果在 // ... 部分发生了异常，v的析构函数会被自动调用。<br /></strong></p>
<p><strong>引入智能指针可以防止出现悬垂指针的情况<br /></strong>一般是把指针封装到一个称之为智能指针类中，这个类中另外还封装了一个使用计数器，对指针的复制等操作将导致该计数器的值加1，对指针的delete操作则会减1，值为0时，指针为NULL</p>
<p>在C++中，内存资源的管理经常是一个令人头痛的问题，指针的错误使用经常是造成内存泄露和“未定义行为”的根源。很多资源被动态分配与heap内而后被用于单一区块或函数内。它们应该在控制流离开那个区块或函数时被释放。智能指针就是针对这种形势而设计的特制产品。它是一种外观和行为都被设计成与内建的指针相类似的对象，不过它提供更多的功能，其析构函数会自动对其所指的对象调用delete来进行删除。</p>
<p>常用的智能指针有auto_ptr(C++标准库提供），shared_ptr(tr1库提供，最为常用），另外还有scoped_ptr，intrusive_ptr，weak_ptr（均为tr1库提供）。在此着重介绍auto_ptr以及shared_ptr两种，在文章最后会对其他智能指针也进行简单的介绍。</p>
<p><strong>1、auto_ptr</strong>:它允许程序员创建一个指向某种资源的指针对象，当该对象离开它的作用域时，它所指向的资源也会被自动释放。在此类中对*和-&gt;运算符进行了重载，使它可以像指针一样被使用，另外它也提供get（），reset（），release（）等方法来供外界取出和重新设置它所指向的对象，详细内容参考<a href="http://blog.csdn.net/xkyx_cn/archive/2009/03/05/3960569.aspx" rel="external nofollow noreferrer">[5]</a>以及C++标准库的说明文档。下面通过一个示例来展示auto_ptr的使用。<br />[code=cpp]//文件名为test_auto_ptr.cpp<br />//auto_ptr位于&lt;memory&gt;头文件中</p>
<p>#include &lt;memory&gt;<br />#include &lt;iostream&gt;</p>
<p>using namespace std;         <br />class MyClass {<br />public:<br />     int i;<br />   MyClass(int s) {i=s;}<br />   ~MyClass() {cout&lt;&lt;"This class has been destroied. "&lt;&lt;i&lt;&lt;endl;}<br />   void myFunc() {cout&lt;&lt;"myFunc() done. "&lt;&lt;i &lt;&lt;endl;}<br />};            </p>
<p>int main() {<br />   auto_ptr&lt;MyClass&gt; ptr1(new MyClass(1));            <br />   auto_ptr&lt;MyClass&gt;ptr2(new MyClass(2));<br />   ptr1-&gt;myFunc();          <br />   ptr2-&gt;myFunc();<br />   cout&lt;&lt;"test 1 done"&lt;&lt;endl;<br />    <br />   ptr2 = ptr1;<br />   ptr2-&gt;myFunc();          <br />   //ptr1-&gt;myFunc();//取消注释会发生段错误或未定义结果<br />    cout&lt;&lt;"test 2 done"&lt;&lt;endl;<br />   <br />   MyClass* ptr = ptr2.get();          <br />   ptr-&gt;myFunc();           <br />     ptr2.reset(new MyClass(3));<br />   ptr2-&gt;myFunc();<br />   ptr-&gt;myFunc(); //此处会产生未定义的结果<br />   cout&lt;&lt;"test 3 done"&lt;&lt;endl;<br />   return 0;<br />}    [/code]</p>
<p>编译并运行：</p>
<p><code>#g++ -g -o test_auto_ptr test_auto_ptr.cpp</code></p>
<p># ./test_auto_ptr</p>
<p>运行结果如下：<br /><code>myFunc() done. 1<br />myFunc() done. 2<br />test 1 done<br />This class has been destroied. 2<br />myFunc() done. 1<br />test 2 done<br />myFunc() done. 1<br />This class has been destroied. 1<br />myFunc() done. 3<br />myFunc() done. 0<br />test 3 done<br />This class has been destroied. 3</code></p>
<p>从上面的结果可以看出auto_ptr具有智能指针的功能，但是由于auto_ptr被销毁时会自动删除它所指之物，所以一定要注意不要让多个auto_ptr同时指向同一对象，否则一个对象会被删除多次，这会导致“未定义的行为”。另外，auto_ptr在进行复制时会产生一些诡异的行为，如进行ptr2=ptr1;之后ptr2指向对象，而ptr1会被设为NULL，调用ptr1会产生未定义行为（或段错误）。由此也可以看出auto_ptr不能用于STL容器中。</p>
<p><strong>2、shared_ptr</strong>:它是一种引用计数型智能指针，它的复制行为相比auto_ptr要正常许多，它也可以被自由用于STL容器中。但是shared_ptr类不属于标准C++库，而是属于tr1库（C++ tr1是针对C++标准库的第一次扩展。即将到来的下一个版本的C++标准c++0x会包括它，以及一些语言本身的扩充），现在的编译器对于tr1库的支持良莠不齐，但是从gcc 4.0开始就实现了对于shared_ptr的支持。shared_ptr的用法和auto_ptr类似，具体参见<a href="http://www.boost.org/doc/libs/1_40_0/libs/smart_ptr/shared_ptr.htm" rel="external nofollow noreferrer">[1] </a>。下面通过示例来介绍shared_ptr的使用：</p>
<p>[code=cpp]//文件名为test_shared_ptr.cpp<br />//shared_ptr位于 &lt;tr1/memory&gt; 头文件中</p>
<p>#include &lt;tr1/memory&gt;<br />#include &lt;iostream&gt;<br />#include&lt;vector&gt;<br />using namespace std;<br />using std::tr1::shared_ptr;         <br />class MyClass {<br />public:<br />   int i;<br />   MyClass(int s) {i=s;}<br />   ~MyClass() {cout&lt;&lt;"This class has been destroied. "&lt;&lt; i &lt;&lt;endl;}<br />   void myFunc() {cout&lt;&lt;"myFunc() done. "&lt;&lt; i &lt;&lt;endl;}<br />};            </p>
<p>int main() {</p>
<p>//下面分别建立两个智能指针，然后测试他们的基本使用<br />//注意不能使用如下形式： shared_ptr&lt;MyClass&gt; ptr = new MyClass(2);<br />   shared_ptr&lt;MyClass&gt; ptr1(new MyClass(1));            <br />   shared_ptr&lt;MyClass&gt;ptr2(new MyClass(2));<br />   (*ptr1).myFunc();          <br />   ptr2-&gt;myFunc();<br />   cout&lt;&lt;"test 1 done!"&lt;&lt;endl;<br />    <br />    <br />     //下面尝试复制操作，并进行把两个<br />   ptr2 = ptr1;<br />   ptr2-&gt;myFunc();          <br />   ptr1-&gt;myFunc();<br />   ptr1.reset();<br />   cout&lt;&lt;"ptr1.reset() done!"&lt;&lt;endl;<br />   ptr2.reset();<br />   cout&lt;&lt;"test 2 done!"&lt;&lt;endl; <br />     <br />      <br />   MyClass* temp_ptr=new MyClass(3);<br />   ptr1.reset(temp_ptr);//把普通指针委托给智能指针进行托管          <br />   ptr1-&gt;myFunc(); //注意委托之后不要使用delete，否则程序会出现异常，轻则出错，重则挂掉<br />    //delete temp_ptr;         <br />   cout&lt;&lt;"test 3 done"&lt;&lt;endl;<br />  <br />  <br />   //智能指针也可以放入STL容器中，并且不影响其使用<br />   //注意这里MyClass&gt; 后面有一个空格，否则会被当作一个&gt;&gt;运算符<br />   vector&lt;shared_ptr&lt;MyClass&gt; &gt; myVector;<br />         {<br />     shared_ptr&lt;MyClass&gt; temp_shared_ptr(new MyClass(4));<br />    myVector.push_back(temp_shared_ptr);<br />         }//离开temp_shared_ptr的作用域，只是它自己析构，MyClass并不会析构<br />  <br />   vector&lt;shared_ptr&lt;MyClass&gt; &gt;::iterator itor =myVector.begin();</p>
<p>   (*itor)-&gt;myFunc();<br />   myVector.clear();<br />   cout&lt;&lt;"test 4 done!"&lt;&lt;endl;</p>
<p>   return 0;<br />}</p>
<p>[/code]</p>
<p>编译并运行：</p>
<p><code># g++ -g -o test_shared_ptr test_shared_ptr.cpp</code></p>
<p>#./test_shared_ptr</p>
<p>运行结果如下：<br /><code>myFunc() done. 1<br />myFunc() done. 2<br />test 1 done!<br />This class has been destroied. 2<br />myFunc() done. 1<br />myFunc() done. 1<br />ptr1.reset() done!<br />This class has been destroied. 1<br />test 2 done!<br />myFunc() done. 3<br />test 3 done<br />myFunc() done. 4<br />This class has been destroied. 4<br />test 4 done!<br />This class has been destroied. 3</code></p>
<p>从运行结果中也可以看出shared_ptr 具有很好的资源管理的能力，可以实现理想的复制操作，并且可以和STL容器兼容。在多线程情况下shared_ptr可以达到和c++内置类型同等的安全性。无疑shared_ptr类将是tr1中最常使用的类型。</p>
<p>但是shared_ptr并不是尽善尽美的，它还存在环状引用等问题。在使用shared_ptr时也有一些注意事项需要遵守，否则反而会弄巧成拙。文章<a href="http://blog.liancheng.info/archives/85" rel="external nofollow noreferrer">[3]</a>中指出了一些shared_ptr的缺点，不防也看看，有些地方说的还是有道理的。</p>
<p><strong>3、其他一些智能指针介绍</strong>：</p>
<p>scoped_ptr 与auto_ptr类似，但是不允许复制；<br />intrusive_ptr是shared_ptr侵入式版本。使用情况，内部以及编写好了自己的内部引用计算器的代码，而又没有时间重写它。intrusive_ptr可以从this构造。<br />weak_ptr是智能指针shared_ptr的观察者。</p>
<p>上面只是对于智能指针的一个简单的介绍和示例的说明，我也是刚开始学习智能指针，希望上面的内容对大家有帮助。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 06:25:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/test/" title="test">test</a>, <a href="https://www.iamivan.net/tag/ptr/" title="PTR">PTR</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>auto_ptr,shared_ptr 智能指针的使用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2WOnVM.html" rel="bookmark">C&plus;&plus;中auto&lowbar;ptr智能指针的用法详解&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				智能指针(auto_ptr) 这个名字听起来很酷是不是?其实auto_ptr 只是C++标准库提供的一个类模板,它与传统的new/delete控制内存相比有一定优势,但也有其局限.本文总结的8个问题足以涵盖auto_ptr的大部分内容. auto_ptr是什么? auto_ptr 是C++标准库提供的类模板,auto_ptr对象通过初始化指向由new创建的动态内存,它是这块内存的拥有者,一块内存不能同时被分给两个拥有者.当auto_ptr对象生命周期结束时,其析构函数会将auto_ptr对象拥有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9WOwvz.html" rel="bookmark">C&plus;&plus;中的auto&lowbar;ptr智能指针的作用及使用方法详解&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				智能指针(auto_ptr) 这个名字听起来很酷是不是?其实auto_ptr 只是C++标准库提供的一个类模板,它与传统的new/delete控制内存相比有一定优势,但也有其局限.本文总结的8个问题足以涵盖auto_ptr的大部分内容.  auto_ptr是什么? auto_ptr 是C++标准库提供的类模板,auto_ptr对象通过初始化指向由new创建的动态内存,它是这块内存的拥有者,一块内存不能同时被分给两个拥有者.当auto_ptr对象生命周期结束时,其析构函数会将auto_ptr对象拥			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4P99p.html" rel="bookmark">Google C&plus;&plus;编程风格指南（四）：智能指针和其他C&plus;&plus;特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.对于智能指针,安全第一.方便第二,尽可能局部化(scoped_ptr): 2.引用形参加上const,否则使用指针形参:3.函数重载的使用要清晰.易读:4.鉴于容易误用,禁止使用缺省函数参数(值得商榷):5.禁止使用变长数组:6.合理使用友元-- Google特有的风情 Google有很多自己实现的使C++代码更加健壮的技巧.功能,以及有异于别处的C++的使用方式. 1.智能指针(Smart Pointers) 如果确实需要使用智能指针的话,scoped_ptr完全可以胜任.在非常特殊的情况			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq72VOz.html" rel="bookmark">c&plus;&plus;11教程 智能指针讲解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果在程序中使用new从堆(自由存储区)分配内存,等到不需要时, 应使用delete将其释放.c++引入了智能指针auto_ptr, 以帮助自动完成这个过程. c++11摒弃了auto_ptr,并新增了三种智能指针:unique_ptr, shared_ptr, weak_ptr. 一. auto_ptr, unique_ptr , shared_ptr 头文件:  #include &lt;memory&gt; 用法:auto_ptr&lt;double&gt;  A(new double);uniqu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badGvnz.html" rel="bookmark">C&plus;&plus; auto&lowbar;ptr智能指针的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章转载自: http://blog.csdn.net/monkey_d_meng/article/details/5901392 C++中指针申请和释放内存通常采用的方式是new和delete.然而标准C++中还有一个强大的模版类就是auto_ptr,它可以在你不用的时候自动帮你释放内存.下面简单说一下用法. 用法一: std::auto_ptr&lt;T&gt;m_example(new T()); 用法二: std::auto_ptr&lt;T&gt;m_example; m_example.res			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ20PYz.html" rel="bookmark">浅析Boost智能指针&colon;scoped&lowbar;ptr shared&lowbar;ptr weak&lowbar;ptr&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. scoped_ptrboost::scoped_ptr和std::auto_ptr非常类似,是一个简单的智能指针,它能够保证在离开作用域后对象被自动释放.下列代码演示了该指针的基本应用: 复制代码 代码如下: #include &lt;string&gt;#include &lt;iostream&gt;#include &lt;boost/scoped_ptr.hpp&gt; class implementation{public:    ~implementation() { std::cout			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zw5R0OM.html" rel="bookmark">智能指针&lpar;二&rpar;&colon;shared&lowbar;ptr实现原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面讲到auto_ptr有个很大的缺陷就是所有权的转移,就是一个对象的内存块只能被一个智能指针对象所拥有.但我们有些时候希望共用那个内存块.于是C++ 11标准中有了shared_ptr这样的智能指针,顾名思义,有个shared表明共享嘛.所以shared_ptr类型的智能指针可以做为STL容器的元素   下面我们来瞧瞧shared_ptr具体是咋实现的.相较auto_ptr有下面几个不同的地方: 1.引进了一个计数器shared_count,用来表示当前有多少个智能指针对象共享指针指向的内存块			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1o3Oz.html" rel="bookmark">C&plus;&plus;智能指针auto&lowbar;ptr详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				auto_ptr auto_ptr是C++标准库中()为了解决资源泄漏的问题提供的一个智能指针类模板(注意:这只是一种简单的智能指针) auto_ptr的实现原理其实就是RAII,在构造的时候获取资源,在析构的时候释放资源,并进行相关指针操作的重载,使用起来就像普通的指针. std::auto_ptr&lt;ClassA&gt; pa(new ClassA); 1 1 但是由于其构造函数声明为explicit的,因此不能通过饮食转换来构造,只能显示调用构造函数 例如 auto_ptr&lt;string&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWQEEz.html" rel="bookmark">C&plus;&plus;智能指针&lpar;auto&lowbar;ptr&rpar;详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				智能指针(auto_ptr) 这个名字听起来很酷是不是?其实auto_ptr 只是C++标准库提供的一个类模板,它与传统的new/delete控制内存相比有一定优势,但也有其局限.本文总结的8个问题足以涵盖auto_ptr的大部分内容.   1. auto_ptr是什么? auto_ptr 是C++标准库提供的类模板,auto_ptr对象通过初始化指向由new创建的动态内存,它是这块内存的拥有者,一块内存不能同时被分给两个拥有者.当auto_ptr对象生命周期结束时,其析构函数会将auto_pt			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEW0Zp.html" rel="bookmark" class="title">分区助手调整硬盘分区大小图文教程</a>
					<div>
						  任务环境: 假设用户的Windows 7系统中有一个36GB磁盘,其上有3个分区,一个是100MB的保留分区E盘,第二个是系统分区C盘15.01GB,第三个是数据分区F盘20.89GB. 任务目标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7QnqM.html" rel="bookmark" class="title">网页-【前端】彩色关键词怎么实现？</a>
					<div>
						问题描述 [前端]彩色关键词怎么实现? 在一个div里面无序地排列五颜六色的关键词,关键词字体不一样,大小不一样,颜色不一样,而且没有段落.关键词是从数据库读取的,动态生成网页.请问如何实现? 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bolDXM.html" rel="bookmark" class="title">网页制作代码的18个技巧</a>
					<div>
						使用css好处是一次改变全部改变,这点可以很好的利用在换皮肤的应用中. 1.xml文件尽量以utf-8编码,gb2312有些字是存储不了的,如?,就算能存也需要转换,比较麻烦,utf-8也符合国际规范 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1noap.html" rel="bookmark" class="title">限制Flash在指定域名&sol;网址中播放</a>
					<div>
						今天测试的时候发现这个方法,限制 Flash 在指定域名中播放.可能这个方法有些老了,不过还是有一定防止破解的效果,我亲自尝试了不得不强行结束任务. url = &quot;http://www.we ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxE9rb.html" rel="bookmark" class="title">squid源码安装的服务启动脚本</a>
					<div>
						#!/bin/bash # squid This shell script takes care of starting and stopping # Squid Internet Object Ca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOxROb.html" rel="bookmark" class="title">解决SQL Server转ACCESS自动编号问题</a>
					<div>
						1.打开SQL server enterprise mananger &quot;企业管理器&quot; 在你要导出的SQL数据库上鼠标右键菜单:所有任务-&gt;导出数据 2.回出现一个导出向导窗口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62jYLM.html" rel="bookmark" class="title">asp 过滤数组重复数据</a>
					<div>
						function array_no(cxstr1,cxstr2,cxstr3) if len(cxstr3) &gt; 0 then if not IsNumeric(cxstr3) then arr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eYWYb.html" rel="bookmark" class="title">word如何制作插入logo</a>
					<div>
						  1.首先,你可以通过photoshop制作自己的logo,或者你也可以通过电脑自带的画图工具进行绘制,当然你需要有一定的美术功底.如果是企业logo一般都是直接制作好的,那就节省了第一步,不需要自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWgXOb.html" rel="bookmark" class="title">jQuery实现点击该行即可删除HTML表格行</a>
					<div>
						 jQuery的已成为所有时刻的最常用和最喜爱的JavaScript框架之一.它不仅不会减少在JavaScript编码简单的技术开销,而且也使您的代码的跨浏览器兼容.我已经写了许多关于jQuery教程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7XV7M.html" rel="bookmark" class="title">不同网段共享打印机的方法</a>
					<div>
						  跨网段共享打印机的困难 假设内部局域网有两个子网&quot;192.168.1*&quot;和&quot;192.168.2.*&quot;. &quot;192.168.1*&quot;网段内的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYR60Zp.html" rel="bookmark" class="title">canceling statement due to conflict with recovery</a>
					<div>
						报错: canceling statement due to conflict with recovery DETAIL:  User query might have needed to see r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6E6Bz.html" rel="bookmark" class="title">YII 分页排序</a>
					<div>
						'defaultOrder'=&gt;array('title' =&gt; false), false是升序,true是倒叙 1.自定义分页 使用CPagination呈现相关信息到页码. 当数据需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q6Knp.html" rel="bookmark" class="title">华南农业大学：赏三月紫荆校园 看万千无线花开</a>
					<div>
						阳春三月,草长莺飞,华南农业大学(以下简称&quot;华农&quot;)的紫荆花美得甚是醉人.&quot;紫荆校园&quot;已成为华农的一张文化名片.从今年三月开始,在华农的校园内盛开的不仅是紫荆花 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxaX5b.html" rel="bookmark" class="title">&lpar;译）OpenGL ES2&period;0 &ndash; Iphone开发指引</a>
					<div>
						纯的不能再纯的转载,原译者说别人是牛人,不过在我看来,他也挺牛的了. 刚接触OpenGL ES时,这篇文章不知看了多少遍了,只能照本宣科,不知其然与其所以然. 后决定放弃这种不负责任的工作方式,虽然不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEVjOp.html" rel="bookmark" class="title">永远用小的结果集驱动大的结果集</a>
					<div>
						转载自:公司内  数据工程师:  永远用小的结果集驱动大的结果集 很多人喜欢在优化 SQL 的时候使用小表驱动大表,个人认为这不太严谨.为什么?因为大表经过 WHERE 条件过滤之后返回的结果集并不一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32v03z.html" rel="bookmark" class="title">线程-关于Win32核心编程中DLL注入后无反应的解决办法</a>
					<div>
						问题描述 关于Win32核心编程中DLL注入后无反应的解决办法 #include #include HINSTANCE hProcess; PWSTR pszLibFileRemote; HINSTA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAXQKM.html" rel="bookmark" class="title">mapxtreme参数无效&comma;Command&period;js</a>
					<div>
						问题描述 mapxtreme2008开发地图,在IE8中运行示例程序,点击放大.缩小.平移等自带工具,地图没反应,显示脚本错误:参数无效,Command.js文件.望高手解答! 解决方案 解决方案二: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZYjRz.html" rel="bookmark" class="title">在Windows下编译ffmpeg完全手册</a>
					<div>
						本文的内容几乎全部来自于FFmpeg on Windows,但是由于国内的网络封锁,很难访问这个域名下的内容,因此我一方面按照我自己的理解和实践做了翻译,另一方面也是为了能提供一个方便的参考方法. 注 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQ9Wmp.html" rel="bookmark" class="title">使用PuTTY上传文件</a>
					<div>
						要完成这些操作,Windows内必须有完整的PuTTy安装包而不仅仅是putty.exe这一个文件  open calpico.dreamhost.com 用于连接远程linux服务器,其中calpi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnvoNM.html" rel="bookmark" class="title">markdown for 蝉知 2&period;1&period;1，简单修复移动端展示</a>
					<div>
						蝉知markdown编辑器于10月30日更新到2.0版本,但是由于系统设置原因(我的个人站点设置将移动端关闭了),导致测试移动端时自动跳转到了pc端,导致移动端使用会出现部分问题. 蝉知markdow ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12v7ap.html" rel="bookmark" class="title">数据越大，存储领域需求越大</a>
					<div>
						如今全世界范围内都对大数据技术和服务的需求不断提升,大数据技术堆栈的各个层面也已经迎来了显著的增长.存储是基础架构组件中的重要组成部分,在2011年到2016年之间将一直保持53%的复合年增长率(简称 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jAykp.html" rel="bookmark" class="title">JavaScript中几个重要的属性&lpar;this、constructor、prototype&rpar;介绍&lowbar;基础知识</a>
					<div>
						this this表示当前对象,如果在全局作用范围内使用this,则指代当前页面对象window: 如果在函数中使用this,则this指代什么是根据运行时此函数在什么对象上被调用. 我们还可以使用a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmdjRp.html" rel="bookmark" class="title">关于对河南网通封锁局域网共享上网的破解&lowbar;漏洞研究</a>
					<div>
						关于突破网通限制上网的几种办法,首先是网上的三种办法  1.首先运行&quot;河南通信宽带用户客户端&quot;程序:(NPF驱动程序被加载)   2.打开&quot;河南通信宽带共享&quot;: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkq3oM.html" rel="bookmark" class="title">完善养老金运营</a>
					<div>
						5日,人社部就社会保险关系转续及医药卫生体制改革等问题集中答复网友时明确表示,将适时提出弹性延迟领取基本养老金年龄的政策建议.人民网(603000,股吧)推出的调查显示,11478个网友中,有74.5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk7P9M.html" rel="bookmark" class="title">北电破产之谜：是现金烧光还是战略错误</a>
					<div>
						1月25日,曾经的电信巨头北电网络正式向法院 提出申请破产保护.商业周刊就此发表评论文章称,面对日益加重的债务和日渐缩水的现金流,北电网络申请破产保护无疑是一个明智之举, 但是其CEO迈克·扎菲罗夫斯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2ZGOM.html" rel="bookmark" class="title">oracle flashback详解3</a>
					<div>
						原文转自:http://www.askmaclean.com/archives/why-flashback-log-smaller-than-redolog.html 为什么Flashback Log ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPW2ErM.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;全国律师咨询日&rdquo;市民对它还很陌生</a>
					<div>
						本报讯(记者 林志雄)昨天是第26个&quot;全国律师咨询日&quot;,记者走访发现,不少市民对这个纪念日都感到陌生. 据了解,&quot;全国律师咨询日&quot;是1986年中华全国律师协会成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenla8b.html" rel="bookmark" class="title">cheap air fore shoes</a>
					<div>
						问题描述 Dearcustomers,Welcometoourwebsite(http://www.china-cheap-sneaker.com)!Wespecializeinexportingva ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgdWRz.html" rel="bookmark" class="title">谷歌、微软等互联网巨头公司是怎么招到一流人才的？</a>
					<div>
						谷歌.Facebook.苹果.亚马逊等这些顶尖高科技公司每年都会收到&quot;千万亿&quot;量级的简历,可以肯定:他们有自己筛选人才的方法,但那究竟是什么呢? 答案,绝不是网上很火的那套&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqN4vp.html" rel="bookmark" class="title">以股权融资29亿元奇瑞汽车谋划海外收购与A股上市</a>
					<div>
						□ 本报记者 孙中元 在安徽有这样一家汽车企业,他们的汽车频现在全国各地的大街小巷,同时大量出口俄罗斯和北美等海外国家,但这家企业每卖一辆车只有1000多元的利润.这就是芜湖的奇瑞汽车. 直到最近,奇 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
